function [Price,distrib,lost,Vseq]=equilibrium(median,lambda,N,sd,prob,agingS,r,tailcoef,resvalue)

K=1000;
mu=log(median);
r=r+agingS;
resperiod=resvalue*r/(r+lambda); % reservation value per period
tail=logncdf(tailcoef*resvalue,mu,sd); % probability that v<v(reservation)
vmin=0.0000001;
pv=linspace(tail+vmin,0.5-vmin,K); % grid of probablities for possible values
values=logninv(pv,mu,sd); % grid for possible values
u=zeros(N+1,K); %continuation value of the captive to the seller
P=zeros(N+1,K); % next offer price
P(1,:)=values; % there is no trade after the last offer, so the next price is set to the value
ksinum=zeros(N,K);

for i=1:N-2
[u(i+1,:), ksinum(i,:)]=max(triu((r/(lambda+r)*repmat(values',1,K)-resperiod+...
    lambda/(lambda+r)*repmat(P(i,:)',1,K)).*...
    (repmat(pv,K,1)-repmat(pv',1,K))/(1-tail)+lambda/(lambda+r)*repmat(u(i,:)',1,K)+resperiod+...
    lambda/(lambda+r)*(repmat(pv',1,K)-tail)/(1-tail)*resvalue*(i==1)));
P(i+1,:)=r/(lambda+r)*values(ksinum(i,:))+lambda/(lambda+r)*P(i,ksinum(i,:));
end
i=N-1;
[u(i+1,:), ksinum(i,:)]=max((1-prob)*triu((r/(lambda+r)*repmat(values',1,K)-resperiod+...
    lambda/(lambda+r)*repmat(P(i,:)',1,K)).*...
    (repmat(pv,K,1)-repmat(pv',1,K))/(1-tail)+lambda/(lambda+r)*repmat(u(i,:)',1,K))+resperiod+...
    prob*triu((r/(lambda+r)*repmat(values',1,K)-resperiod+...
    lambda/(lambda+r)*repmat(P(i,:)',1,K)).*...
    (repmat(1-vmin,K,K)-repmat(pv',1,K))/(1-tail)+resperiod+lambda/(lambda+r)*repmat(u(i,:)',1,K)));
P(i+1,:)=r/(lambda+r)*values(ksinum(i,:))+lambda/(lambda+r)*P(i,ksinum(i,:));

i=N;
[u(i+1,:), ksinum(i,:)]=max((1-prob)*triu((r/(lambda+r)*repmat(values',1,K)-resperiod+...
    lambda/(lambda+r)*repmat(P(i,:)',1,K)).*...
    (repmat(1-vmin,K,K)-repmat(pv',1,K))/(1-tail)+lambda/(lambda+r)*repmat(u(i,:)',1,K))+resperiod+...
    prob*(lambda/(lambda+r)*repmat(u(i,:)',1,K)+resperiod));
P(i+1,:)=r/(lambda+r)*values(ksinum(i,:))+lambda/(lambda+r)*P(i,ksinum(i,:));

Price=zeros(N,1);
Vseq=zeros(N,1);

%Ksiseq(end)=values(end);
%Price(end)=P(N+1,end);
ksicurrent=K;

for i=1:N
    Price(N+1-i)=P(N+2-i,ksicurrent);
    ksicurrent=ksinum(N+1-i,ksicurrent);
    Vseq(N+1-i)=values(ksicurrent);
end
Price=flipud(Price);
distrib=flipud(diff([logncdf(Vseq,mu,sd);1]))/(1-tail);
lost=(logncdf(Vseq(1),mu,sd)-tail)/(1-tail);
Vseq=flipud(Vseq);
gtemp=distrib(1);
distrib(1)=gtemp*(1-prob);
distrib(2)=distrib(2)*(1-prob)+(gtemp+distrib(2))*prob;