
lambda=0.35; %arrival probability
K=6; %cutoff for the max number of offers
x=0.027482063;
T=1000;
factor=[0.3,0.6,1,1.4,1.7];
seller_share=zeros(length(factor),length(factor));
buyer_share=zeros(length(factor),length(factor));
delay_share=zeros(length(factor),length(factor));

for k=1:length(factor)
    for m=1:length(factor)
        results=[0.441902913,0.30614847,x*factor(m),0.065782012,1.592998034,0.232811878*exp(1)];
        N=ceil(K*factor(k));
        % surplus distribution
        [pricefunc,distrib,lost,Vseq]=equilibrium(exp(1),lambda*factor(k),N,results(1),results(2)...
            ,results(3),results(4),results(5),results(6)); %computing equilibrium
        beta=lambda/(lambda+results(3)+results(4));
        powers=0:1:N-1;
        tail=logncdf(results(6)*results(5),1,results(1));
        sellervalue=sum((beta.^powers'.*pricefunc+results(6)*(1-beta.^powers')).*distrib)+...
            lost*beta^N*results(6)-results(6);
        pv=linspace(tail+0.0001,0.9999,T);
        vbuyer=logninv(pv,1,results(1));
        buyervalue=(vbuyer-pricefunc(1)).*(vbuyer>Vseq(1))*(1-results(2));
        buyervalue=buyervalue+(1-results(2))*beta*(vbuyer-pricefunc(2)).*(vbuyer>Vseq(2)).*(vbuyer<Vseq(1))+...
            results(2)*beta*(vbuyer-pricefunc(2)).*(vbuyer>Vseq(2));
        for i=3:N
            buyervalue=buyervalue+beta^(i-1)*(vbuyer-pricefunc(i)).*(vbuyer>Vseq(i)).*(vbuyer<Vseq(i-1));
        end
        buyervalue=sum(buyervalue)/T;
        totvalue=sum(vbuyer)/T-results(6);
        delaycosts=totvalue-sellervalue-buyervalue;
        seller_share(k,m)=sellervalue/totvalue*100;
        buyer_share(k,m)=buyervalue/totvalue*100;
        delay_share(k,m)=delaycosts/totvalue*100;
    end
end
